Best Time to Buy and Sell Stock II 最佳时间买入卖出股票(多次买卖)@LeetCode

来源:互联网 发布:网络彩票开售 编辑:程序博客网 时间:2024/04/23 17:16

题目:

最佳时间买入卖出股票:你有一个数组保存了股票在第i天的价钱,现在你可以进行多次买入卖出,但同一时间你手上只能保持一个股票,如何赚的最多

思路:

贪心法,本题和前面的Best Time to Buy and Sell Stock 不同在于,本题可以多次买卖股票,
从而累积赚取所有的价格差。因此用贪心法,基本思想是锁定一个低价,然后在价格升到局部最高点
(即下一天的价钱就下降了)时候,抛出股票,然后把下一天较低的价钱作为买入,接着计算。
要注意最后要处理最后一次的利润


package Level3;/** * Best Time to Buy and Sell Stock II *  *  Say you have an array for which the ith element is the price of a given stock on day i.Design an algorithm to find the maximum profit. You may complete as many transactions as you like (ie, buy one and sell one share of the stock multiple times). However, you may not engage in multiple transactions at the same time (ie, you must sell the stock before you buy again). * */public class S122 {public static void main(String[] args) {int[] prices = {2,1,2,0,4};System.out.println(maxProfit(prices));}// 贪心法,本题和前面的Best Time to Buy and Sell Stock 不同在于,本题可以多次买卖股票,// 从而累积赚取所有的价格差。因此用贪心法,基本思想是锁定一个低价,然后在价格升到局部最高点// (即下一天的价钱就下降了)时候,抛出股票,然后把下一天较低的价钱作为买入,接着计算。// 要注意最后要处理最后一次的利润public static int maxProfit(int[] prices) {if(prices.length == 0){return 0;}        int totalProfit = 0;        int startIndex = 0;        int i;                for(i=1; i<prices.length; i++){        if(prices[i] < prices[i-1]){// 因为第i天的价钱就下降了,因此把从startIndex到i-1的利润积累到总利润中        totalProfit += prices[i-1] - prices[startIndex];        startIndex = i;// 更新startIndex        }        }    // 记得要处理最后一次的利润        if(prices[i-1] > prices[startIndex]){        totalProfit += prices[i-1] - prices[startIndex];        }                return totalProfit;    }}


Again:

public class Solution {    public int maxProfit(int[] prices) {                if(prices.length == 0){            return 0;        }                int profits = 0;        int minBuy = prices[0];        for(int i=1; i<prices.length; i++){            if(prices[i] < prices[i-1]){                profits += prices[i-1]-minBuy;                minBuy = prices[i];            }else{                            }        }        if(prices[prices.length-1] > minBuy){            profits += prices[prices.length-1]-minBuy;        }        return profits;    }}


其实最简单的做法是:

计算每个相邻的diff差,只要diff大于0,就累积起来

public class Solution {    public int maxProfit(int[] prices) {        int len = prices.length;        if(len == 0) {            return 0;        }                int max = 0;        for(int i=1; i<len; i++) {            int diff = prices[i] - prices[i-1];            if(diff > 0) {                max += diff;            }        }        return max;    }}






原创粉丝点击